DROP DATABASE IF EXISTS `SCSP`;

CREATE DATABASE `SCSP`
  CHARACTER SET `utf8`
  COLLATE `utf8_general_ci`;

USE `SCSP`;

CREATE TABLE `usuaris` (
`idUsuari` varchar(20) NOT NULL,
`nom` varchar(20),
`contrassenya` varchar(20) NOT NULL default '1234',
`email` varchar(30) NOT NULL,
`direccio` varchar(60) default NULL,
`tipus` int(11) default '0',
`actiu` boolean default TRUE,
`comentaris` varchar(255),
`tel1` varchar(20),
`tel2` varchar(20),
PRIMARY KEY (`idUsuari`)
);

CREATE TABLE `clients` (
`idClient` varchar(20) NOT NULL,
`descriptor` varchar(20) NOT NULL,
`nom` varchar(20) NOT NULL,
`email` varchar(30) NOT NULL,
`direccio` varchar(60) default NULL,
`actiu` boolean default TRUE,
`comentaris` varchar(255),
`tel1` varchar(20) NOT NULL,
`tel2` varchar(20),
PRIMARY KEY (`idClient`)
);

CREATE TABLE `projectes` (
`idProjecte` varchar(20) NOT NULL,
`descriptor` varchar(20) NOT NULL,
`horespressupost` int(11) default '0',
`despesespressupost` int(11) default '0',
`horesfacturades` int(11) default '0',
`despesesfacturades` int(11) default '0',
`actiu` boolean default TRUE,
`descripcio` varchar(255),
`idClient` varchar(20) NOT NULL,
`idProjectManager` varchar(20) NOT NULL,
PRIMARY KEY (`idProjecte`),
FOREIGN KEY (`idClient`) references `clients` (`idClient`) on delete cascade,
FOREIGN KEY (`idProjectManager`) references `usuaris` (`idUsuari`) on delete cascade
);

CREATE TABLE `horari` (
`id` int(11) NOT NULL default '0',
`idUsuari` varchar(20) NOT NULL,
`idProjecte` varchar(20) NOT NULL,
`setmana` varchar(20) NOT NULL,
`horesDilluns` int(11) default '0',
`horesDimarts` int(11) default '0',
`horesDimecres` int(11) default '0',
`horesDijous` int(11) default '0',
`horesDivendres` int(11) default '0',
`horesDissabte` int(11) default '0',
`horesDiumenge` int(11) default '0',
`descripcio` varchar(255),
PRIMARY KEY (`id`),
UNIQUE (`idUsuari`,`idProjecte`,`setmana`),
FOREIGN KEY (`idUsuari`) references `usuaris` (`idUsuari`) on delete cascade,
FOREIGN KEY (`idProjecte`) references `projectes` (`idProjecte`) on delete cascade
);

CREATE TABLE `conceptes` (
`idDespesa` varchar(20) NOT NULL,
`descriptor` varchar(20) NOT NULL,
`actiu` boolean default TRUE,
`facturable` boolean default '0',
`descripcio` varchar(255),
PRIMARY KEY (`idDespesa`)
);

CREATE TABLE `despeses` (
`id` int(11) NOT NULL default '0',
`idDespesa` varchar(20) NOT NULL,
`idUsuari` varchar(20) NOT NULL,
`idProjecte` varchar(20) NOT NULL,
`data` DATE NOT NULL,
`valor` DOUBLE default '0',
`descripcio` varchar(255),
PRIMARY KEY (`id`),
UNIQUE (`idDespesa`, `idUsuari`, `idProjecte`, `data`),
FOREIGN KEY (`idDespesa`) references `conceptes` (`idDespesa`) on delete cascade,
FOREIGN KEY (`idUsuari`) references `usuaris` (`idUsuari`) on delete cascade,
FOREIGN KEY (`idProjecte`) references `projectes` (`idProjecte`) on delete cascade
);