package ters.dao;

import java.util.Collection;
import java.util.ArrayList;
import java.util.List;
import ters.dao.hibernate.*;

import org.springframework.dao.DataAccessException;


public interface SpringHibernateDAO {
	

	public boolean checkUserLogin(String strUserName, String strPassword) throws DataAccessException,java.sql.SQLException;
   

	public void afegirUsuari(ters.dao.hibernate.Usuari obj) throws DataAccessException;



	public void afegirConcepte(ters.dao.hibernate.Concepte obj) throws DataAccessException;


	public void afegirClient(ters.dao.hibernate.Client obj) throws DataAccessException;


	public void afegirProjecte(ters.dao.hibernate.Projecte obj) throws DataAccessException;


	public void afegirHorari(ters.dao.hibernate.Horari obj) throws DataAccessException;


	public void afegirDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException;


	public void updateUsuari(ters.dao.hibernate.Usuari obj) throws DataAccessException;


	public void updateConcepte(ters.dao.hibernate.Concepte obj) throws DataAccessException;


	public void updateClient(ters.dao.hibernate.Client obj) throws DataAccessException;


	public void updateProjecte(ters.dao.hibernate.Projecte obj) throws DataAccessException;


	public void updateHorari(ters.dao.hibernate.Horari obj) throws DataAccessException;


	public void updateDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException;


	public void deleteHorari(ters.dao.hibernate.Horari obj) throws DataAccessException;


	public void deleteDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException;


	public ters.dao.hibernate.Usuari loadUsuari(String id) throws DataAccessException;


	public ters.dao.hibernate.Concepte loadConcepte(String id) throws DataAccessException;


	public ters.dao.hibernate.Client loadClient(String id) throws DataAccessException;


	public ters.dao.hibernate.Projecte loadProjecte(String id) throws DataAccessException;


	public ters.dao.hibernate.Horari loadHorari(String id) throws DataAccessException;


	public ters.dao.hibernate.Despesa loadDespesa(String id) throws DataAccessException;
	

	public boolean checkValidUserName(String strUserid) throws DataAccessException,java.sql.SQLException;
	

	public List<String> getUsersList() throws DataAccessException,java.sql.SQLException;


	public List<String> getClientsList() throws DataAccessException,java.sql.SQLException;


	public List<String> getConceptesList() throws DataAccessException,java.sql.SQLException;


	public List<String> getProjectsList() throws DataAccessException,java.sql.SQLException;


	public int getTipus(String strUserid) throws DataAccessException,java.sql.SQLException;
	

    public String[]  retriveUserForgetPassword(String strUserName, String strEmail) throws DataAccessException,java.sql.SQLException;


	public Collection getUsers() throws DataAccessException,java.sql.SQLException;

	public Collection getProjectes() throws DataAccessException,java.sql.SQLException;

	public Collection getFactura(String idProjecte) throws DataAccessException,java.sql.SQLException;

	public int getValorFactura(String idProjecte, String idUsuari)throws DataAccessException,java.sql.SQLException;

	public int getValorFactura(String idProjecte, String idUsuari, String setmana)throws DataAccessException,java.sql.SQLException;

	public Collection getConsulta(String idUsuari, String setmana) throws DataAccessException,java.sql.SQLException;

	public List<Horari> getHorari(String setmana, String idUsuari, int from, int to) throws DataAccessException,java.sql.SQLException;


	public int getNumHorari(String setmana, String idUsuari) throws DataAccessException,java.sql.SQLException;


	public List<Despesa> getDespeses(String idProjecte, String idUsuari, int from, int to) throws DataAccessException,java.sql.SQLException;

	public int getNumDespeses(String idProjecte, String idUsuari) throws DataAccessException,java.sql.SQLException;
	
}

