package ters.dao;

import java.util.ArrayList;
import java.util.List;
import java.util.Collection;
import java.util.*;
import java.util.Date;
import java.util.Calendar;
import java.text.*;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;
import org.hibernate.criterion.*;

import ters.dao.hibernate.*;

import java.sql.*;


/**
 * Hibernate implementation of the JobModule interface.
 * 
 */
public class SpringHibernateDAOImpl extends HibernateDaoSupport implements
		SpringHibernateDAO {

	
//check admin login 

	public boolean checkUserLogin(String strUserName, String strPassword) throws DataAccessException,java.sql.SQLException{

		boolean valid = false;
		Connection conn = this.getSession().connection();
		//Write jdbc code to validate the user against database
		Statement smt = conn.createStatement();
		ResultSet rs;
		//write select query for checking password 
		
		String query="select idUsuari from usuaris where idUsuari='"+strUserName+"' and contrassenya='"+strPassword+"'";
		rs=smt.executeQuery(query);
		
		if(rs.next()== true){
			valid=true;
			
		}else{
			valid=false;
		}
		
		smt.close();
		rs.close();
		conn.close();
		
		return valid;
		
		
	}

	
	public void afegirUsuari(ters.dao.hibernate.Usuari obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

	public void afegirConcepte(ters.dao.hibernate.Concepte obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

	public void afegirClient(ters.dao.hibernate.Client obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

	public void afegirProjecte(ters.dao.hibernate.Projecte obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

	public void afegirHorari(ters.dao.hibernate.Horari obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

	public void afegirDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException{
		getHibernateTemplate().save(obj);
}

public void updateUsuari(ters.dao.hibernate.Usuari obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void updateConcepte(ters.dao.hibernate.Concepte obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void updateClient(ters.dao.hibernate.Client obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void updateProjecte(ters.dao.hibernate.Projecte obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void updateHorari(ters.dao.hibernate.Horari obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void updateDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException{
		getHibernateTemplate().update(obj);
}

public void deleteHorari(ters.dao.hibernate.Horari obj) throws DataAccessException{
		getHibernateTemplate().delete(obj);
}

public void deleteDespesa(ters.dao.hibernate.Despesa obj) throws DataAccessException{
		getHibernateTemplate().delete(obj);
}

public ters.dao.hibernate.Usuari loadUsuari(String id) throws DataAccessException{
			return (ters.dao.hibernate.Usuari) getHibernateTemplate().get(Usuari.class,id);
}

public ters.dao.hibernate.Client loadClient(String id) throws DataAccessException{
			return (ters.dao.hibernate.Client) getHibernateTemplate().get(Client.class,id);
}

public ters.dao.hibernate.Concepte loadConcepte(String id) throws DataAccessException{
			return (ters.dao.hibernate.Concepte) getHibernateTemplate().get(Concepte.class,id);
}

public ters.dao.hibernate.Projecte loadProjecte(String id) throws DataAccessException{
			return (ters.dao.hibernate.Projecte) getHibernateTemplate().get(Projecte.class,id);
}

public ters.dao.hibernate.Horari loadHorari(String id) throws DataAccessException{
			return (ters.dao.hibernate.Horari) getHibernateTemplate().get(Horari.class,new Integer(id));
}

public ters.dao.hibernate.Despesa loadDespesa(String id) throws DataAccessException{
			return (ters.dao.hibernate.Despesa) getHibernateTemplate().get(Despesa.class,new Integer(id));
}
	
public boolean checkValidUserName(String strUserid) throws DataAccessException,java.sql.SQLException{
	boolean valid = false;
	Connection conn = this.getSession().connection();
	//Write jdbc code to validate the user against database
	Statement smt = conn.createStatement();
	ResultSet rs;
	//write select query for checking password 
	
	String query="select idUsuari from usuaris where idUsuari='"+strUserid+"'";
	rs=smt.executeQuery(query);
	
	
	if(rs.next() == true){
		
		valid=true;
		
	}else{
		valid=false;
	}
	
	smt.close();
	rs.close();
	conn.close();
	
	
	return valid;
}


public List<String> getUsersList()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	List<String> list = new ArrayList<String>();
  	
	String query="SELECT idUsuari FROM usuaris";
	
	rs=smt.executeQuery(query);
	
	while(rs.next()){
		
	list.add(rs.getString("idUsuari"));
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public List<String> getClientsList()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	List<String> list = new ArrayList<String>();
  	
	String query="SELECT idClient FROM clients";
	
	rs=smt.executeQuery(query);
	
	while(rs.next()){

	list.add(rs.getString("idClient"));
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public List<String> getConceptesList()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	List<String> list = new ArrayList<String>();
  	
	String query="SELECT idDespesa FROM conceptes";
	
	rs=smt.executeQuery(query);
	
	while(rs.next()){

	list.add(rs.getString("idDespesa"));
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public List<String> getProjectsList()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	List<String> list = new ArrayList<String>();
  	
	String query="SELECT idProjecte FROM projectes";
	
	rs=smt.executeQuery(query);
	
	while(rs.next()){
		
	list.add(rs.getString("idProjecte"));
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public int getTipus(String strUserid) throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	//Write jdbc code to validate the user against database
	Statement smt = conn.createStatement();
	ResultSet rs;
	//write select query for checking password 
	
	String query="select tipus from usuaris where idUsuari='"+strUserid+"'";
	rs=smt.executeQuery(query);
	rs.next();
	
	int tipus=rs.getInt("tipus");
	
	smt.close();
	rs.close();
	conn.close();
	return tipus;
}


// retrive user forget password
public String[] retriveUserForgetPassword(String strUserName, String strEmail) throws DataAccessException,java.sql.SQLException{
	//boolean valid = false;

	
	Connection conn = this.getSession().connection();
	//Write jdbc code to validate the user against database
	Statement smt = conn.createStatement();
	
	ResultSet rs;
	String query;
	
	
	//write select query for checking password 
	 
    if(strUserName != ""){
	          
              query="select contrassenya,email,idUsuari from usuaris where idUsuari='"+strUserName+"'";

	     }else{
	          query="select contrassenya,email,idUsuari from usuaris where email='"+strEmail+"'";
         }
	
	rs=smt.executeQuery(query);
	
    String[] returnValues = new String[3];  
	 

 	while(rs.next()){

	 		returnValues[0]=rs.getString("contrassenya");
	 		returnValues[1]=rs.getString("email"); 
	 		returnValues[2]=rs.getString("idUsuari"); 
 
 	}
 	
 	smt.close();
 	rs.close();
 	conn.close();
 	
 	if(returnValues[0] != null){
 		 
 		return returnValues;
 	
 	}	else{
 		String[] errorValues = new String[2];  
 		errorValues[0]="error";
 		return errorValues;
 	}
}



public Collection getUsers()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList list = new ArrayList();
  	
	String query="SELECT idUsuari FROM usuaris";
	
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){
		
		ters.dao.hibernate.Usuari userslist = loadUsuari(rs.getString("idUsuari"));
				
		list.add(userslist);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public Collection getProjectes()throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList list = new ArrayList();
  	
	String query="SELECT idProjecte FROM projectes";
	
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){
		
		ters.dao.hibernate.Projecte projecteslist = loadProjecte(rs.getString("idProjecte"));
				
		list.add(projecteslist);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public int getValorFactura(String idProjecte, String idUsuari)throws DataAccessException,java.sql.SQLException{

return getValorFactura(idProjecte,idUsuari,"");
}


public int getValorFactura(String idProjecte, String idUsuari,String setmana)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList list = new ArrayList();

	String query = "";

  	
	if (setmana != null && !setmana.equals("")) {

	DateFormat formatter ; 
  	formatter = new SimpleDateFormat("dd/MM/yyyy");

	Date beforeDate = null;
	Date afterDate = null;

	try {
	beforeDate = formatter.parse(setmana);
	afterDate = formatter.parse(setmana);
	} catch (ParseException ex) {
	ex.printStackTrace();
	}

	Calendar cal = Calendar.getInstance();
 	cal.setTime(afterDate);
	cal.add(Calendar.DATE,6);
	afterDate.setTime( cal.getTime().getTime() );

	DateFormat printFormat ; 
  	printFormat = new SimpleDateFormat("yyyy-MM-dd");

	query="SELECT despeses.idUsuari, despeses.idProjecte, Sum(despeses.valor) AS total FROM despeses WHERE (((despeses.data) Between '"+printFormat.format(beforeDate)+"' And '"+printFormat.format(afterDate)+"')) GROUP BY despeses.idUsuari, despeses.idProjecte HAVING (((despeses.idProjecte)='" + idProjecte +  "') AND ((despeses.idUsuari)='" + idUsuari + "'));";


	} else {
	query="SELECT despeses.idUsuari, despeses.idProjecte, Sum(despeses.valor) AS total FROM despeses GROUP BY despeses.idUsuari, despeses.idProjecte HAVING (((despeses.idProjecte)='" + idProjecte +  "') AND ((despeses.idUsuari)='" + idUsuari + "'));";
	}
	
	
	rs=smt.executeQuery(query);
	int result=0;
	
	
	while(rs.next()){
		
		result += rs.getInt("total");
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return result;
}


public Collection getFactura(String idProjecte)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList list = new ArrayList();
  	
	String query="SELECT horari.idUsuari, horari.idProjecte, Sum(horari.horesDilluns+horari.horesDimarts+horari.horesDimecres+horari.horesDijous+horari.horesDivendres+horari.horesDissabte+horari.horesDiumenge) AS hores FROM horari GROUP BY horari.idUsuari, horari.idProjecte HAVING (((horari.idProjecte)='" + idProjecte + "'));";
	
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){
		
		ters.dao.hibernate.Factura factura = new ters.dao.hibernate.Factura();

		factura.setIdUsuari(rs.getString("idUsuari"));
		factura.setIdProjecte(rs.getString("idProjecte"));
		factura.setHores(rs.getInt("hores"));
		factura.setDespeses(getValorFactura(idProjecte,factura.getIdUsuari()));
		list.add(factura);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public Collection getConsulta(String idUsuari, String setmana)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList list = new ArrayList();
  	
	String query="SELECT horari.idUsuari, horari.idProjecte, horari.setmana, Sum(horari.horesDilluns) as dilluns, Sum(horari.horesDimarts) as dimarts, Sum(horari.horesDimecres) as dimecres, Sum(horari.horesDijous) as dijous, Sum(horari.horesDivendres) as divendres, Sum(horari.horesDissabte) as dissabte, Sum(horari.horesDiumenge) as diumenge, Sum(horari.horesDilluns+horari.horesDimarts+horari.horesDimecres+horari.horesDijous+horari.horesDivendres+horari.horesDissabte+horari.horesDiumenge) AS hores FROM horari GROUP BY horari.idUsuari, horari.idProjecte, horari.setmana HAVING (((horari.idUsuari)='" + idUsuari + "') AND ((horari.setmana)='" + setmana + "'));";
	
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){
		
		ters.dao.hibernate.Factura factura = new ters.dao.hibernate.Factura();

		factura.setIdUsuari(rs.getString("idUsuari"));
		factura.setIdProjecte(rs.getString("idProjecte"));
		factura.setHores(rs.getInt("hores"));
		factura.setHoresDilluns(rs.getInt("dilluns"));
		factura.setHoresDimarts(rs.getInt("dimarts"));
		factura.setHoresDimecres(rs.getInt("dimecres"));
		factura.setHoresDijous(rs.getInt("dijous"));
		factura.setHoresDivendres(rs.getInt("divendres"));
		factura.setHoresDissabte(rs.getInt("dissabte"));
		factura.setHoresDiumenge(rs.getInt("diumenge"));
		factura.setDespeses(getValorFactura(factura.getIdProjecte(),factura.getIdUsuari(),setmana));

		list.add(factura);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public List<Horari> getHorari(String setmana, String idUsuari, int from, int to)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList<Horari> list = new ArrayList<Horari>();
  	
	String query="SELECT id,idUsuari,setmana FROM horari WHERE idUsuari='"+idUsuari+"' AND setmana='"+setmana+"'";
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){

		ters.dao.hibernate.Horari horarilist = loadHorari(Integer.toString(rs.getInt("id")));
				
		list.add(horarilist);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public int getNumHorari(String setmana, String idUsuari)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;

	int resultat = 0;
  	
	String query="SELECT count(*) FROM horari WHERE idUsuari='"+idUsuari+"' AND setmana='"+setmana+"'";
	
	rs=smt.executeQuery(query);

	while(rs.next()){

		resultat = rs.getInt(1);

	}
		
	rs.close();
	smt.close();
	conn.close();
	
	return resultat;
}


public List<Despesa> getDespeses(String idProjecte, String idUsuari, int from, int to)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;
	
	ArrayList<Despesa> list = new ArrayList<Despesa>();
  	
	String query="SELECT id,idUsuari,idProjecte FROM despeses WHERE idUsuari='"+idUsuari+"' AND idProjecte='"+idProjecte+"'";
	
	
	rs=smt.executeQuery(query);
	
	
	while(rs.next()){

		ters.dao.hibernate.Despesa despeseslist = loadDespesa(Integer.toString(rs.getInt("id")));
				
		list.add(despeseslist);
 
	}
	
	rs.close();
	smt.close();
	conn.close();
	
	return list;
}


public int getNumDespeses(String idProjecte, String idUsuari)throws DataAccessException,java.sql.SQLException{
	
	Connection conn = this.getSession().connection();
	
	//Write jdbc code 
	Statement smt = conn.createStatement();
	
	ResultSet rs=null;

	int resultat = 0;
  	
	String query="SELECT count(*) FROM despeses WHERE idUsuari='"+idUsuari+"' AND idProjecte='"+idProjecte+"'";
	
	rs=smt.executeQuery(query);

	while(rs.next()){

		resultat = rs.getInt(1);

	}
		
	rs.close();
	smt.close();
	conn.close();
	
	return resultat;
}


}