package ters.web.struts;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import ters.services.ServiceFinder;

public class AfegirUsuari extends ActionSupport implements 
  ServletRequestAware,ServletResponseAware{

	private HttpServletRequest request;
  	private HttpServletResponse response;

  public void setServletRequest(HttpServletRequest request){
  this.request = request;
  }

  public HttpServletRequest getServletRequest(){
  return request;
  }

  public void setServletResponse(HttpServletResponse response){
  this.response = response;
  }

  public HttpServletResponse getServletResponse(){
  return response;
  }

    public String execute() throws Exception {

		//Retrieve the DAO Reference
		ters.dao.SpringHibernateDAO springHibernateDAO = (ters.dao.SpringHibernateDAO) ServiceFinder.getContext(getServletRequest())
		  		.getBean("SpringHibernateDao");

		String strError = "";

		try {

				if (getIdentificador()==null){
					return INPUT;
				} else {

			boolean ValidUsernameStatus = springHibernateDAO
					.checkValidUserName(getIdentificador());

					if (ValidUsernameStatus == false) {

						ters.dao.hibernate.Usuari pojoObj = new ters.dao.hibernate.Usuari();

						pojoObj.setIdUsuari(getIdentificador());
						pojoObj.setContrassenya(getPassword());
						pojoObj.setNom(getNom());
						pojoObj.setDireccio(getDireccio());
						pojoObj.setTipus(Integer.parseInt(getTipus()));
						pojoObj.setTel1(getTel1());
						pojoObj.setTel2(getTel2());
						pojoObj.setEmail(getEmail());
						pojoObj.setComentaris(getComentaris());
						pojoObj.setActiu(true);

						//Add the data
						springHibernateDAO.afegirUsuari(pojoObj);
						
						return SUCCESS;

					} else {

						addActionError("Invalid user name. Please try again!");
						return ERROR;
					}

				}
				
		} catch (Exception e) {
			strError = e.getMessage();
			System.out.println("===> Error:" + strError);
			return ERROR;
		}
	}


    private String identificador = null;

    public String getIdentificador() {
        return identificador;
    }

    public void setIdentificador(String value) {
        identificador = value;
    }


    private String password = null;

    public String getPassword() {
        return password;
    }

    public void setPassword(String value) {
        password = value;
    }


    private String tipus = null;

    public String getTipus() {
        return tipus;
    }

    public void setTipus(String value) {
        tipus = value;
    }


    private String nom = null;

    public String getNom() {
        return nom;
    }

    public void setNom(String value) {
        nom = value;
    }


    private String email = null;

    public String getEmail() {
        return email;
    }

    public void setEmail(String value) {
        email = value;
    }


    private String tel1 = null;

    public String getTel1() {
        return tel1;
    }

    public void setTel1(String value) {
        tel1 = value;
    }


    private String tel2 = null;

    public String getTel2() {
        return tel2;
    }

    public void setTel2(String value) {
        tel2 = value;
    }


    private String direccio = null;

    public String getDireccio() {
        return direccio;
    }

    public void setDireccio(String value) {
        direccio = value;
    }


    private String comentaris = null;

    public String getComentaris() {
        return comentaris;
    }

    public void setComentaris(String value) {
        comentaris = value;
    }


}