package ters.web.struts;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import ters.services.ServiceFinder;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;
import java.util.Calendar;
import java.util.Iterator;
import java.text.*;
import java.util.Collection;
import ters.dao.hibernate.Factura;

public class DetallConsulta extends ActionSupport implements 
  ServletRequestAware,ServletResponseAware{

	private HttpServletRequest request;
  	private HttpServletResponse response;

  public void setServletRequest(HttpServletRequest request){
  this.request = request;
  }

  public HttpServletRequest getServletRequest(){
  return request;
  }

  public void setServletResponse(HttpServletResponse response){
  this.response = response;
  }

  public HttpServletResponse getServletResponse(){
  return response;
  }

private int totalHores=0;
private int totalHoresDilluns=0;
private int totalHoresDimarts=0;
private int totalHoresDimecres=0;
private int totalHoresDijous=0;
private int totalHoresDivendres=0;
private int totalHoresDissabte=0;
private int totalHoresDiumenge=0;
private int totalDespeses=0;

    public String execute() throws Exception {

		//Retrieve the DAO Reference
		ters.dao.SpringHibernateDAO springHibernateDAO = (ters.dao.SpringHibernateDAO) ServiceFinder.getContext(getServletRequest())
		  		.getBean("SpringHibernateDao");

		String strError = "";

		try {

			userList = springHibernateDAO.getUsersList();

			Date date = dia;
			Calendar cal = Calendar.getInstance();
 			cal.setTime(date);
			cal.add(Calendar.DATE,-(cal.get(Calendar.DAY_OF_WEEK) % 7));
			date.setTime( cal.getTime().getTime() );
			DateFormat formatter ; 
  			formatter = new SimpleDateFormat("dd/MM/yyyy"); 
        		setmana = formatter.format(date);

			usersList = springHibernateDAO.getConsulta(identificador, setmana);

			Iterator<Factura> i = usersList.iterator();

			while (i.hasNext()){
				Factura f = i.next();
				totalHores += f.getHores();
				totalHoresDilluns += f.getHoresDilluns();
				totalHoresDimarts += f.getHoresDimarts();
				totalHoresDimecres += f.getHoresDimecres();
				totalHoresDijous += f.getHoresDijous();
				totalHoresDivendres += f.getHoresDivendres();
				totalHoresDissabte += f.getHoresDissabte();
				totalHoresDiumenge += f.getHoresDiumenge();
				totalDespeses += f.getDespeses();
			}

			return SUCCESS;

		} catch (Exception e) {
			strError = e.getMessage();
			System.out.println("===> Error:" + strError);
			return ERROR;
		}
	}


private List<String> userList;

	public List<String> getUserList() {
		return userList;
	}
 
	public void setUserList(List<String> userList) {
		this.userList = userList;
	}

private Collection usersList;

	public Collection getUsersList() {
		return usersList;
	}
 
	public void setUsersList(Collection usersList) {
		this.usersList = usersList;
	}


    private String identificador = null;

    public String getIdentificador() {
        return identificador;
    }

    public void setIdentificador(String value) {
        identificador = value;
    }


    private Date dia;

    public Date getDia() {
        return dia;
    }

    public void setDia(Date value) {
        dia = value;
    }


    private String setmana;

    public String getSetmana() {
        return setmana;
    }

    public void setSetmana(String value) {
        setmana = value;
    }


    public int getTotalHores() {
        return this.totalHores;
    }

    public int getTotalDespeses() {
        return this.totalDespeses;
    }
   
    public int getTotalHoresDilluns() {
        return this.totalHoresDilluns;
    }

    public int getTotalHoresDimarts() {
        return this.totalHoresDimarts;
    }

    public int getTotalHoresDimecres() {
        return this.totalHoresDimecres;
    }

    public int getTotalHoresDijous() {
        return this.totalHoresDijous;
    }

    public int getTotalHoresDivendres() {
        return this.totalHoresDivendres;
    }

    public int getTotalHoresDissabte() {
        return this.totalHoresDissabte;
    }

    public int getTotalHoresDiumenge() {
        return this.totalHoresDiumenge;
    }


}