package ters.web.struts;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import ters.services.ServiceFinder;
import java.util.ArrayList;
import java.util.List;
import java.util.Collection;
import java.util.Iterator;
import ters.dao.hibernate.Factura;

public class DetallFactura extends ActionSupport implements 
  ServletRequestAware,ServletResponseAware{

	private HttpServletRequest request;
  	private HttpServletResponse response;

  public void setServletRequest(HttpServletRequest request){
  this.request = request;
  }

  public HttpServletRequest getServletRequest(){
  return request;
  }

  public void setServletResponse(HttpServletResponse response){
  this.response = response;
  }

  public HttpServletResponse getServletResponse(){
  return response;
  }

	private int totalHores=0;
	private int totalDespeses=0;
    	private int horesPressupost=0;
    	private int despesesPressupost=0;

    public String execute() throws Exception {

		//Retrieve the DAO Reference
		ters.dao.SpringHibernateDAO springHibernateDAO = (ters.dao.SpringHibernateDAO) ServiceFinder.getContext(getServletRequest())
		  		.getBean("SpringHibernateDao");

		String strError = "";

		try {

			projectList = springHibernateDAO.getProjectsList();

			if (getIdentificador() != null && !getIdentificador().equals("")) {
			projectsList = springHibernateDAO.getFactura(identificador);

			ters.dao.hibernate.Projecte projecte = springHibernateDAO.loadProjecte(identificador);
			horesPressupost=projecte.getHores();
			despesesPressupost=projecte.getDespeses();

			Iterator<Factura> i = projectsList.iterator();

				while (i.hasNext()){
				Factura f = i.next();
				totalHores += f.getHores();
				totalDespeses += f.getDespeses();
				}
			}

					return SUCCESS;

		} catch (Exception e) {
			strError = e.getMessage();
			System.out.println("===> Error:" + strError);
			return ERROR;
		}
	}


private List<String> projectList;

	public List<String> getProjectList() {
		return projectList;
	}
 
	public void setProjectList(List<String> projectList) {
		this.projectList = projectList;
	}


private Collection projectsList;

	public Collection getProjectsList() {
		return projectsList;
	}
 
	public void setProjectsList(Collection projectsList) {
		this.projectsList = projectsList;
	}


    private String identificador = null;

    public String getIdentificador() {
        return identificador;
    }

    public void setIdentificador(String value) {
        identificador = value;
    }


    public int getTotalHores() {
        return this.totalHores;
    }

    public int getTotalDespeses() {
        return this.totalDespeses;
    }

    public int getHoresPressupost() {
        return this.horesPressupost;
    }

    public int getDespesesPressupost() {
        return this.despesesPressupost;
    }

    public int getDesviacioDespeses() {
        return this.totalDespeses-this.despesesPressupost;
    }

    public int getDesviacioHores() {
        return this.totalHores-this.horesPressupost;
    }


}