package ters.web.struts;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import ters.services.ServiceFinder;
import java.util.ArrayList;
import java.util.List;

public class DetallProjecte extends ActionSupport implements 
  ServletRequestAware,ServletResponseAware{

	private HttpServletRequest request;
  	private HttpServletResponse response;

  public void setServletRequest(HttpServletRequest request){
  this.request = request;
  }

  public HttpServletRequest getServletRequest(){
  return request;
  }

  public void setServletResponse(HttpServletResponse response){
  this.response = response;
  }

  public HttpServletResponse getServletResponse(){
  return response;
  }

    public String execute() throws Exception {

		//Retrieve the DAO Reference
		ters.dao.SpringHibernateDAO springHibernateDAO = (ters.dao.SpringHibernateDAO) ServiceFinder.getContext(getServletRequest())
		  		.getBean("SpringHibernateDao");

		String strError = "";

		try {

			projectList = springHibernateDAO.getProjectsList();
			clientList = springHibernateDAO.getClientsList();
			userList = springHibernateDAO.getUsersList();

			if (getIdentificador() != null && !getIdentificador().equals("")) {

				ters.dao.hibernate.Projecte pojoObj = springHibernateDAO.loadProjecte(getIdentificador());

				setDescriptor(pojoObj.getDescriptor());
				setIdClient(pojoObj.getIdClient());
				setIdUsuari(pojoObj.getIdUsuari());
				setHores(pojoObj.getHores());
				setDespeses(pojoObj.getDespeses());
				setComentaris(pojoObj.getComentaris());
				setActiu(pojoObj.getActiu());
			}
	
					return SUCCESS;

		} catch (Exception e) {
			strError = e.getMessage();
			System.out.println("===> Error:" + strError);
			return ERROR;
		}
	}


private List<String> projectList;

	public List<String> getProjectList() {
		return projectList;
	}
 
	public void setProjectList(List<String> projectList) {
		this.projectList = projectList;
	}

private List<String> clientList;

	public List<String> getClientList() {
		return clientList;
	}
 
	public void setClientList(List<String> clientList) {
		this.clientList = clientList;
	}


private List<String> userList;

	public List<String> getUserList() {
		return userList;
	}
 
	public void setUserList(List<String> userList) {
		this.userList = userList;
	}


    private String identificador = null;

    public String getIdentificador() {
        return identificador;
    }

    public void setIdentificador(String value) {
        identificador = value;
    }


    private String descriptor = null;

    public String getDescriptor() {
        return descriptor;
    }

    public void setDescriptor(String value) {
        descriptor = value;
    }


    private String idClient = null;

    public String getIdClient() {
        return idClient;
    }

    public void setIdClient(String value) {
        idClient = value;
    }


    private String idUsuari = null;

    public String getIdUsuari() {
        return idUsuari;
    }

    public void setIdUsuari(String value) {
        idUsuari = value;
    }


    private int hores = 0;

    public int getHores() {
        return hores;
    }

    public void setHores(int value) {
        hores = value;
    }


    private int despeses = 0;

    public int getDespeses() {
        return despeses;
    }

    public void setDespeses(int value) {
        despeses = value;
    }


    private String comentaris = null;

    public String getComentaris() {
        return comentaris;
    }

    public void setComentaris(String value) {
        comentaris = value;
    }


    private boolean actiu = false;

    public boolean getActiu() {
        return actiu;
    }

    public void setActiu(boolean value) {
        actiu = value;
    }


}