package ters.web.struts;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import org.apache.struts2.interceptor.SessionAware;
import ters.services.ServiceFinder;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;
import java.util.Calendar;
import java.text.*;
import java.util.*;
import ters.dao.hibernate.Horari;

public class GridHorari extends ActionSupport implements SessionAware{

  //Your result List
  private List<Horari>      gridModel;

  //get how many rows we want to have into the grid - rowNum attribute in the grid
  private Integer             rows             = 0;

  //Get the requested page. By default grid sets this to 1.
  private Integer             page             = 0;

  // sorting order - asc or desc
  private String              sord;

  // get index row - i.e. user click to sort.
  private String              sidx;

  // Search Field
  private String              searchField;

  // The Search String
  private String              searchString;

  // he Search Operation ['eq','ne','lt','le','gt','ge','bw','bn','in','ni','ew','en','cn','nc']
  private String              searchOper;

  // Your Total Pages
  private Integer             total            = 0;

  // All Record
  private Integer             records          = 0;

  private boolean             loadonce         = false;
  private Map<String, Object> session;


    public String execute(){

		//Retrieve the DAO Reference
		ters.dao.SpringHibernateDAO springHibernateDAO = (ters.dao.SpringHibernateDAO) ServiceFinder.getContext(org.apache.struts2.ServletActionContext.getServletContext())
		  		.getBean("SpringHibernateDao");

		String strError = "";

		try {

			Map session = ActionContext.getContext().getSession();
			String idUsuari = (String)session.get("userID");

    			int to = (rows * page);
    			int from = to - rows;

    			records = springHibernateDAO.getNumHorari(setmana,idUsuari);

    			gridModel = springHibernateDAO.getHorari(setmana,idUsuari,from,to);

    			//calculate the total pages for the query
    			total =(int) Math.ceil((double)records / (double)rows);

			return SUCCESS;

		} catch (Exception e) {
			strError = e.getMessage();
			System.out.println("===> Error:" + strError);
			return ERROR;
		}
	}


  public String getJSON()
  {
    return execute();
  }


    private String setmana;

    public String getSetmana() {
        return setmana;
    }

    public void setSetmana(String value) {
        setmana = value;
    }


  /**
   * @return how many rows we want to have into the grid
   */
  public Integer getRows()
  {
    return rows;
  }

  /**
   * @param rows
   *          how many rows we want to have into the grid
   */
  public void setRows(Integer rows)
  {
    this.rows = rows;
  }

  /**
   * @return current page of the query
   */
  public Integer getPage()
  {
    return page;
  }

  /**
   * @param page
   *          current page of the query
   */
  public void setPage(Integer page)
  {
    this.page = page;
  }

  /**
   * @return total pages for the query
   */
  public Integer getTotal()
  {
    return total;
  }

  /**
   * @param total
   *          total pages for the query
   */
  public void setTotal(Integer total)
  {
    this.total = total;
  }

  /**
   * @return total number of records for the query. e.g. select count(*) from
   *         table
   */
  public Integer getRecords()
  {
    return records;
  }

  /**
   * @param record
   *          total number of records for the query. e.g. select count(*) from
   *          table
   */
  public void setRecords(Integer records)
  {

    this.records = records;

    if (this.records > 0 && this.rows > 0)
    {
      this.total = (int) Math.ceil((double) this.records / (double) this.rows);
    }
    else
    {
      this.total = 0;
    }
  }

  /**
   * @return an collection that contains the actual data
   */
  public List<Horari> getGridModel()
  {
    return gridModel;
  }

  /**
   * @return sorting order
   */
  public String getSord()
  {
    return sord;
  }

  /**
   * @param sord
   *          sorting order
   */
  public void setSord(String sord)
  {
    this.sord = sord;
  }

  /**
   * @return get index row - i.e. user click to sort.
   */
  public String getSidx()
  {
    return sidx;
  }

  /**
   * @param sidx
   *          get index row - i.e. user click to sort.
   */
  public void setSidx(String sidx)
  {
    this.sidx = sidx;
  }

  public void setSearchField(String searchField)
  {
    this.searchField = searchField;
  }

  public void setSearchString(String searchString)
  {
    this.searchString = searchString;
  }

  public void setSearchOper(String searchOper)
  {
    this.searchOper = searchOper;
  }

  public void setLoadonce(boolean loadonce)
  {
    this.loadonce = loadonce;
  }

  public void setSession(Map<String, Object> session)
  {
    this.session = session;
  }


}